import * as axios from 'axios';

type swarmConfig = {
    radius?: number;
    near?: string | undefined;
    broadcast?: string;
    venueId?: string;
    oauth_token?: string;
    m?: string;
    v: string;
    ll: string;
    altAcc: string;
    llAcc: string;
    alt?: string;
    user_id?: string;
    limit?: number;
    afterTimeStamp?: string;
    floorLevel?: string;
};

declare class SwarmappApi {
    config: swarmConfig;
    basePath: string;
    headers: any;
    user: any;
    flowId?: string;
    initialize: any;
    getFriends: any;
    getFollowings: any;
    getFollowers: any;
    getUser: any;
    addFriendByID: any;
    checkIn: any;
    getRecent: any;
    getCheckins: any;
    completemultifactorlogin: any;
    initiatemultifactorlogin: any;
    getTrending: any;
    getVenue: any;
    log: any;
    error: any;
    getLL: any;
    constructor();
    constructor(oauth_token: string);
    getLastSeen(user_id?: string, limit?: number): any;
    getGeos(user_id?: string): Promise<any>;
    private_log(): Promise<axios.AxiosResponse<any, any> | undefined>;
    register_device(): Promise<any>;
    addHereNow(checkin: any, females_only?: boolean): Promise<{
        hereNow: any;
        friendships: any[];
    }>;
    autoAddTrending(location_name: string, limit_trending: number): Promise<any[]>;
    likeCheckin(checkin_id: string): Promise<axios.AxiosResponse<any, any> | undefined>;
    likeUnliked(limit?: number): Promise<{
        succeeded: any[];
        failed: any[];
    }>;
}

export { SwarmappApi as default };
